
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'supervisor'
                        AND sysobjects.name = 'rhcontrato' )
    ALTER TABLE rhcontrato ADD supervisor NUMERIC(8,0)
    
GO

if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='rhindicacng' 
                 and c.name='Av_priv_nombre')
  ALTER TABLE  rhindicacng ADD Av_priv_nombre VARCHAR(100) NULL
go

if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='rhindicacng' 
                 and c.name='Av_priv_telefono')
  ALTER TABLE  rhindicacng ADD Av_priv_telefono VARCHAR(100) NULL
go
if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='rhindicacng' 
                 and c.name='Av_priv_direccion')
  ALTER TABLE  rhindicacng ADD Av_priv_direccion VARCHAR(100) NULL
go

if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='rhindicacng' 
                 and c.name='Av_priv_correo')
  ALTER TABLE  rhindicacng ADD Av_priv_correo VARCHAR(100) NULL
go


IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'CargaEmpleadosGeneradorDocumentos'
                    AND type = 'P' ) 
    DROP PROCEDURE CargaEmpleadosGeneradorDocumentos
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaEmpleadosGeneradorDocumentos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaEmpleadosGeneradorDocumentos
GO

CREATE PROCEDURE dbo.CargaEmpleadosGeneradorDocumentos
    (
		@companyId AS Integer,
		@userId as varchar(50)
    )

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
   SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @idPerfil as bigint
    declare @tipoNomina as varchar(15)
    declare @centroCostos as varchar(15)
    
    declare @selectString as varchar(1024)
    declare @fromString as varchar(1024)
    declare @whereString as varchar(1024)
    
    set @selectString=' Select distinct(e.codigo), e.nombre, e.ap_paterno, e.ap_materno, e.sindicato,  c.nomdepto '
    set @fromString  =' from empleados e, llaves ll, centros c, contratos t'  
    set @whereString ='	where e.empresa='+ convert(varchar(50),@companyId) + '
						and e.empresa = ll.empresa 
						and e.empresa = c.empresa 
						and e.empresa = t.empresa 
						and e.codigo=ll.codigo 
						and e.codigo=t.codigo 
						and c.centro=ll.centro 
						and e.activo=''S'''
        
    select @idPerfil=isnull(idperfil,0)
    from perfil_usuarios
    where usuario=@userId
    
    select @tipoNomina=nomina
    from perfiles
    where idperfil=@idPerfil
    
    select @centroCostos=COUNT(centro)
    from perfil_centro
    where idperfil=@idPerfil
	 
	if len(@tiponomina)>2
		begin	     
			set @tipoNomina = SUBSTRING(@tipoNomina,2,len(@tipoNomina)-1)
			set @whereString=@whereString + ' and ll.tiponom in (' + @tipoNomina + ')'
		end

   	if @centroCostos>0
		begin	     
			set @tipoNomina = SUBSTRING(@tipoNomina,2,len(@tipoNomina)-1)
			set @whereString=@whereString + ' and c.centro in (select centro from perfil_centro where idperfil=' + convert(varchar(50),@idPerfil) + ')'
		end			
   
   exec (@selectString + @fromString + @whereString)   
   
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'GeneradorDocumentosCargaEmpleados'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GeneradorDocumentosCargaEmpleados
GO

CREATE PROCEDURE dbo.GeneradorDocumentosCargaEmpleados
    (
		@companyId AS Integer,
		@userId as varchar(50)
    )

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @idPerfil as bigint
    declare @tipoNomina as varchar(15)
    declare @centroCostos as varchar(15)
    
    declare @selectString as varchar(1024)
    declare @fromString as varchar(1024)
    declare @whereString as varchar(1024)
    
    set @selectString=' Select distinct(e.codigo), e.nombre, e.ap_paterno, e.ap_materno, e.sindicato,  c.nomdepto '
    set @fromString  =' from empleados e, llaves ll, centros c, contratos t'  
    set @whereString ='	where e.empresa='+ convert(varchar(50),@companyId) + '
						and e.empresa = ll.empresa 
						and e.empresa = c.empresa 
						and e.empresa = t.empresa 
						and e.codigo=ll.codigo 
						and e.codigo=t.codigo 
						and c.centro=ll.centro 
						and e.activo=''S'''
        
    select @idPerfil=isnull(idperfil,0)
    from perfil_usuarios
    where usuario=@userId
    
    select @tipoNomina=nomina
    from perfiles
    where idperfil=@idPerfil
    
    select @centroCostos=COUNT(centro)
    from perfil_centro
    where idperfil=@idPerfil
	 
	if len(@tiponomina)>2
		begin	     
			set @tipoNomina = SUBSTRING(@tipoNomina,2,len(@tipoNomina)-1)
			set @whereString=@whereString + ' and ll.tiponom in (' + @tipoNomina + ')'
		end

   	if @centroCostos>0
		begin	     
			set @tipoNomina = SUBSTRING(@tipoNomina,2,len(@tipoNomina)-1)
			set @whereString=@whereString + ' and c.centro in (select centro from perfil_centro where idperfil=' + convert(varchar(50),@idPerfil) + ')'
		end			
   
   exec (@selectString + @fromString + @whereString)   
   
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'GeneradorDocumentosCargaEmpleadosDetalle'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GeneradorDocumentosCargaEmpleadosDetalle
GO

CREATE PROCEDURE dbo.GeneradorDocumentosCargaEmpleadosDetalle
    (
		@companyId AS bigint,
		@employeeId as bigint
    )

AS 
      SELECT	e.codigo, 
				rtrim(e.nombre) + ' ' + rtrim(e.ap_paterno) + ' ' + rtrim(e.ap_materno) as nombreEmpleado,  
				ltrim(rtrim(str(e.afiliacion))) + ltrim(rtrim(str(e.digvera))) as afiliacion,  
				ltrim(rtrim(e.rfcalfa)) +  ltrim(rtrim(str(e.rfcnum))) + ltrim(rtrim(e.rfchomo)) as rfc, 
				e.curp,
				e.tiposal, 
				e.jornada,
				convert(varchar(12), e.fchantigua,103) as fechaAntigua,  
				convert(varchar(12), e.fchantigua, 103) as fechaAntigua, 
				isnull(e.lugnac,'') as lugarNacimiento,
				convert(varchar(12), e.fchnac,103) as fechaNAcimiento,  
				convert(varchar(12), e.fchnac, 103)  as fechaNAcimiento,
				e.edonac, 
				e.sexo,
				e.sindicato,
				isnull(e.turno,0) as turno, 
				d.nacional,
				d.domicilio,
				d.poblacion,
				d.codpostal, 
				d.telefono, 
				d.edocivil, 
				c.nomdepto, 
				ll.tiponom,
				t.actividad,
				(datediff(DD,E.fchnac,getdate())/365) as edad, 
				 convert(varchar(12), e.fchalta,103), 
				 convert(varchar(12), e.fchalta,103), 
				 d.colonia,  
				 c.centro, 
				 e.fchnac, 
				 datediff(dd,e.fchantigua,getdate()) as diasAntiguedad, 
				 ll.tiponom, 
				 e.cta_bco_no,
				 e.fchantigua 
             FROM	empleados e inner join datosemps d on e.codigo= d.codigo and e.empresa=d.empresa
								inner join llaves ll on e.codigo=ll.codigo and e.empresa=ll.empresa
								inner join tabulador t on t.empresa=e.empresa and t.ocupacion=ll.ocupacion
								inner join centros c on c.empresa=e.empresa and c.centro=ll.centro
             where e.empresa=d.empresa 
				 and e.empresa=ll.empresa  
				 and e.empresa=t.empresa 
				 and e.empresa=c.empresa 
				 and e.codigo=d.codigo  
				 and e.codigo=ll.codigo 
				 and t.ocupacion=ll.ocupacion 
				 and c.centro=ll.centro 
				 and e.empresa= @companyId
				 and e.codigo= @employeeId
go
/**********************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaContratos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaContratos
GO

CREATE PROCEDURE dbo.CargaContratos
    (
		@companyId AS bigint,
		@employeeId as bigint
    )

AS 
	 select folio, 
			convert(varchar(10), fchalta,103), 
			dias, 
			convert(varchar(10), fchterm,103)
     from contratos 
     where empresa=@companyId
		and codigo=@employeeId
     order by folio desc 
go

/**********************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosDatosEmpresa'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosDatosEmpresa
GO

CREATE PROCEDURE dbo.CargaDocumentosDatosEmpresa
    (
		@companyId AS bigint
    )

AS 
BEGIN
	Select nombre_empresa, 
		   registro_patronal,  
		   rfc_empresa, 
		   infonavit, 
		   direccion_empresa + ' ' + colonia_empresa , 
		   poblacion_empresa,  
		   representante_legal,  
		   codigo_postal_empresa,
		   puesto_representante,
		   colonia_empresa,
	       ltrim(substring(poblacion_empresa, charindex(',',poblacion_empresa,1)+1,LEN(poblacion_empresa))) as estado 
	from empresas 
	where empresa=@companyId
END
GO

/**************************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosDatosAReemplazar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosDatosAReemplazar
GO

CREATE PROCEDURE dbo.CargaDocumentosDatosAReemplazar
    (
		@companyId AS bigint,
		@codigo as bigint,
		@serial as bigint
    )

AS 
BEGIN

	 SELECT  e.codigo,
			 rtrim(e.nombre) + ' ' + rtrim(e.ap_paterno) + ' ' + rtrim(e.ap_materno), 
			 ltrim(rtrim(str(e.afiliacion))) + ltrim(rtrim(str(e.digvera))), 
			 e.rfcalfa +  convert(varchar(6),e.rfcnum) + e.rfchomo as rfc,
			 e.curp, 
			 e.tiposal, 
			 e.jornada, 
			 convert(varchar(12), e.fchantigua,103), 
			 convert(varchar(12), e.fchantigua, 103),
			 isnull(e.lugnac,''), 
			 convert(varchar(12), e.fchnac,103), 
			 convert(varchar(12), e.fchnac, 103), 
			 e.edonac,
			 e.sexo,
			 e.sindicato,
			 isnull(e.turno,0),
			 d.nacional,
			 d.domicilio,
			 d.poblacion,
			 d.codpostal, 
			 d.telefono, 
			 d.edocivil,
			 c.nomdepto, 
			 ll.tiponom,
			 t.actividad,
			 (datediff(DD,E.fchnac,getdate())/365),
			 convert(varchar(12),e.fchalta,103), 
			 convert(varchar(12),e.fchalta,103), 
			 d.colonia, 
			 c.centro,
			 e.fchnac, 
			 datediff(dd,e.fchantigua,getdate()),
			 ll.tiponom, 
			 e.cta_bco_no,
			 e.fchantigua,
			 d.domicilio,
			 d.numeroExterior,
			 d.numeroInterior,
			 d.municipio,
			 d.localidad,
			 d.poblacion,
			 d.email,
			 d.UMF,
			 t.descripcion,
			 rtrim(e.ap_paterno) + ' ' + rtrim(e.ap_materno) + ' ' + rtrim(e.nombre),
			 (CONVERT(varchar(9),h.horario) + ' - ' + h.nombre) as horario,
			 dbo.CalculaAyosAntiguedad(e.fchantigua,getdate()) as ayosAntiguedad
	 FROM empleados e, 
			 datosemps d, 
			 llaves ll, 
			 tabulador t,  
			 centros c, 
			 empleados eb, 
			 horarios_catalogo h
	 where e.empresa=d.empresa
			 and e.empresa=ll.empresa
			 and e.empresa=t.empresa
			 and e.empresa=c.empresa
			 and e.codigo=d.codigo
			 and e.codigo=ll.codigo
			 and t.ocupacion=ll.ocupacion
			 and ll.horario=h.horario
			 and h.empresa=e.empresa
			 and c.centro=ll.centro
			 and e.empresa=@companyID
			 and e.codigo=@codigo
            
END
GO 

/**************************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarPrivacidad'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarPrivacidad
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarPrivacidad
    (
		@companyId AS bigint
    )

AS 
	BEGIN
	 
		Select  isnull(Av_priv_nombre,''), 
				isnull(Av_priv_direccion,''),  
				isnull(Av_priv_correo,''), 
				isnull(Av_priv_telefono,'') 
        From rhindicacng  
        Where empresa=@companyId
	
	END
GO 

/**************************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarEscolaridad'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarEscolaridad
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarEscolaridad
    (
		@companyId AS bigint,
		@codigo as bigint
    )

AS 
	BEGIN
	 
		select  ISNULL(RHNIVEL.NIVEL,'') 
        from rhestudios 
        LEFT JOIN RHNIVEL ON RHNIVEL.IDNIVEL=RHESTUDIOS.idnivel 
        LEFT JOIN rhSOLICITA ON RHESTUDIOS.idsolicitudes= rhsolicita.idsolicitudes  
        LEFT JOIN rhcatalogo ON RHSOLICITA.IDCATALOGO=rhcatalogo.Idcatalogo 
        WHERE rhcatalogo.codigo=@codigo
        and empresa=@companyId
	
	END
GO           

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarContratos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarContratos
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarContratos
    (
		@companyId AS bigint,
		@codigo as bigint
    )

AS 
	BEGIN
		select folio, convert(varchar(10), isnull(fchalta,'19000101'),103), 
				convert(varchar(12),isnull(fchalta,'19000101') , 106), dias, 
				convert(varchar(10), isnull(fchterm,'19000101'),103),  
				convert(varchar(12), isnull(fchterm,'19000101'), 106),
			case tipo 
			when 0 then 'Permanente' 
			when 1 then 'Temporal'   
			when 2 then 'Capacitacin inicial'  
			when 3 then 'De prueba'  
			else 'Sin tipo de contrato asignado' 
			end as tipoContrato 
			from contratos 
		where empresa=@companyId
			and codigo=@codigo
		order by folio desc
   END
GO


/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarHijos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarHijos
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarHijos
    (
		@companyId AS bigint,
		@codigo as bigint
    )

AS 
   BEGIN
		select rtrim(f.nombre) 
		from rhfamiliar f, rhparentesco p, rhcatalogo c
		where f.idparentesco=p.idparentescO
		and P.parentesco='HIJO/A'
		and c.idcatalogo=f.idcatalogo
		and c.empresa= @companyId
		and c.codigo=@codigo
   END
GO


/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarDatosBancarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarDatosBancarios
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarDatosBancarios
    (
		@companyId AS bigint,
		@codigo as bigint
    )

AS 
   BEGIN

	select bancos.nombre , empleadoAdicional.clabe  
	from llaves inner join empleadoAdicional on llaves.empresa = empleadoAdicional.empresa 
	and llaves.codigo=empleadoAdicional.codigo  
	inner join bancos on bancos.banco=Llaves.banco 
	WHERE llaves.empresa= @companyId
	and llaves. codigo=@codigo

   END
GO

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarPeriodos'
                    AND type = 'P' ) 
    DROP PROCEDURE  dbo.CargaDocumentosReemplazarPeriodos
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarPeriodos
    (
		@companyId AS bigint,
		@tiponomina as bigint
    )

AS 
   BEGIN
		SELECT  periodo, 
				convert(varchar(12), inicio, 103), 
				convert(varchar(12), cierre, 103)
        from  periodos 
        where empresa=@companyID
			  and estatus='A'
			  and tiponom=@tiponomina
   END
GO
       
/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarSolicitud'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarSolicitud
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarSolicitud
    (
		@companyId AS bigint,
		@codigo as bigint
    )

AS 
   BEGIN       
              
		Select rhc.idcontrato, 
		convert(varchar(12),rhc.fchalta,103), 
		rhc.dias, 
		rhc.sueldo, 
		rhc.saldiaInt, 
		rhc.tiposal, 
		rhc.tiponom, 
		rhc.sindicato, 
		rhc.UMF, 
		convert(varchar(12),rhc.fchcontrato,103), 
		rhc.contrato, 
		rhc.tipocontrato, 
		rhc.Idcatalogo, 
		rhc.empresa, 
		rhc.clase, 
		rhc.ocupacion, 
		rhc.horario, 
		rhc.centro, 
		rhc.fchreal, 
		rhc.exportado,
		tab.actividad,
		rhcat.codigo,
		case When RTRIM(rhper.nombres)+' '+RTRIM(rhper.ap_paterno)+' '+RTRIM(rhper.ap_materno) is null 
			then  RTRIM(Emp.nombre)+' '+RTRIM(Emp.ap_paterno)+' '+RTRIM(Emp.ap_materno)
			When RTRIM(rhper.nombres)+' '+RTRIM(rhper.ap_paterno)+' '+RTRIM(rhper.ap_materno) IS NOT NULL 
			then RTRIM(rhper.nombres)+' '+RTRIM(rhper.ap_paterno)+' '+RTRIM(rhper.ap_materno)
			end as nombre, 
		rhper.afiliacion,
		rhper.rfc, 
		rhper.curp, 
		rhper.sexo,
		rhper.domicilio, 
		rhper.colonia, 
		rhper.poblacion, 
		rhper.cp,
		rhper.telefono,
		rhper.edo_civil, 
		convert(varchar(12),
		rhper.fch_nac,103), 
		rhper.nacional,
		isnull(rhc.supervisor,0), 
		isnull(rhcat.empresa,0), 
		isnull(rhper.idestados,0), 
		(datediff(DD,rhc.fchcontrato,getdate())/365),
		convert(varchar(12),(rhc.fchcontrato + (rhc.dias-1)),103), 
		rhc.tipocontrato,
		convert(varchar(12),rhc.fchalta,106), 
		convert(varchar(12),rhc.fchcontrato,106), 
		convert(varchar(12),rhper.fch_nac,106)
		from rhcontrato as rhc 
		left join tabulador  as tab   on rhc.ocupacion=tab.ocupacion 
		and rhc.empresa=tab.empresa
		left join rhpersonal as rhper on rhc.idcatalogo=rhper.idcatalogo
		left join rhcatalogo as rhcat on rhc.idcatalogo=rhcat.idcatalogo 
		left join empleados  as Emp   on rhcat.Codigo=Emp.codigo 
		and rhcat.empresa=Emp.empresa where (rhcat.exportado='N' or rhcat.exportado is null) 
		and rhc.empresa=@companyid
		and rhcat.codigo=@codigo
	end             
GO    

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarConyuge'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarConyuge
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarConyuge
    (
		@companyId AS bigint,
		@codigo as bigint
    )
AS 
   BEGIN  
		select f.nombre 
		from rhfamiliar f, rhparentesco p, rhcatalogo c
		where f.idparentesco=p.idparentesco
		and P.parentesco='ESPOSO/A'
		and c.idcatalogo=f.idcatalogo
		and c.empresa=@companyid
		and c.codigo=@codigo         
	END
GO     

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarCuentaTotal'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarCuentaTotal
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarCuentaTotal
    (
		@companyId AS bigint,
		@codigo as bigint,
		@tipo as varchar(5),
		@serial as bigint
    )
AS 
   BEGIN  
		SELECT count(*) FROM kardex
		where empresa = @companyId
		and codigo    = @codigo
		and NOMINA    = 'FIN' 
		and TPAGO_DESC= @tipo
		and serial=@serial            
	END
GO    

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarTotal'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarTotal
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarTotal
    (
		@companyId AS bigint,
		@codigo as bigint,
		@tipo as varchar(5),
		@serial as bigint
    )
AS 
   BEGIN  
		SELECT sum(importe) 
		FROM kardex
		where empresa = @companyId
		and codigo = @codigo
		and NOMINA = 'FIN' 
		and TPAGO_DESC = @tipo
		and serial=@serial            
	END
GO          


/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaDocumentosReemplazarBeneficiarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaDocumentosReemplazarBeneficiarios
GO

CREATE PROCEDURE dbo.CargaDocumentosReemplazarBeneficiarios
    (
		@companyId AS bigint,
		@codigo as bigint
    )
AS 
   BEGIN  
		select  'Nombre: ' + rtrim(rhfamiliar.nombre) + ', ' +
				'Parentesco: ' + rtrim(rhparentesco.parentesco) + ', ' +
				'Porcentaje: ' + convert(varchar(10),rtrim(rhfamiliar.porcentaje) + '%')
		from rhfamiliar
		left join rhcatalogo on rhfamiliar.Idcatalogo=rhcatalogo.Idcatalogo
		left join rhparentesco on rhparentesco.idparentesco=rhfamiliar.idparentesco
		where rhcatalogo.codigo=@codigo  
		and rhfamiliar.beneficia='S'
		and rhcatalogo.empresa=@companyid      
	END
GO               

/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaValoresCamposVariables'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaValoresCamposVariables
GO

CREATE PROCEDURE dbo.CargaValoresCamposVariables
    (
		@companyId AS bigint,
		@codigo as bigint
    )
AS 
   BEGIN 
	    create table #temporal (nombre varchar(50), valor varchar(100))
	    
	     insert into #temporal  select 'campo_02', isnull(campo_02,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo				 	   
		
	     insert into #temporal  select 'campo_03', isnull(campo_03,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
	     insert into #temporal  select 'campo_04', isnull(campo_04,0)
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo		
						 	   
		insert into #temporal  select 'campo_05', isnull(campo_05,0)
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo	
						 	   
		insert into #temporal  select 'campo_07', isnull(campo_07,0)
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
	     insert into #temporal  select 'campo_08', isnull(campo_08,0)
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
						 	   
		insert into #temporal  select 'campo_10', isnull(convert(varchar(10),campo_10,103),'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo	
						 	   
		insert into #temporal  select 'campo_11', isnull(convert(varchar(10),campo_10,103),'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo	
						 	   		
						 	   
		insert into #temporal  select 'campo__09' , isnull(campo__09,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
	     insert into #temporal  select 'campo__10' , isnull(campo__10,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo		
						 	   
		insert into #temporal  select 'campo__11' , isnull(campo__11,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
	     insert into #temporal  select 'campo__12' , isnull(campo__12,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo		
						 	   
		 insert into #temporal  select 'campo__13' , isnull(campo__13,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
	     insert into #temporal  select 'campo__14' , isnull(campo__14,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo		
						 	   
	      insert into #temporal  select 'campo__15' , isnull(campo__15,'')
							   from clasificacion_empleados 
						  	   where empresa=@companyId
						 	   and codigo=@codigo
						 	   
		select * from #temporal

	END
GO   

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargaNombresCamposVariables'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargaNombresCamposVariables
GO

CREATE PROCEDURE dbo.CargaNombresCamposVariables
    (
		@companyId AS bigint
    )
AS 
   BEGIN 
   
	select empresa, 
	case campo
		when 2 then 'campo_02'
		when 3 then 'campo_03'
		when 4 then 'campo_04'
		
		when 5 then 'campo_05'
		when 7 then 'campo_07'
		when 8 then 'campo_08'

		when 10 then 'campo_10'
		when 11 then 'campo_11'
		when 12 then 'campo__09'
		
		when 13 then 'campo__10'
		when 14 then 'campo__11'
		when 15 then 'campo__12'
		
		when 16 then 'campo__13'
		when 17 then 'campo__14'
		when 18 then 'campo__15'
	end as campo, etiqueta
	from clasificacion_etiquetas 
	where empresa=@companyId

	END
GO             


/***********************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'generadorContratosCargaListadoEmpleados'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.generadorContratosCargaListadoEmpleados
GO

CREATE PROCEDURE dbo.generadorContratosCargaListadoEmpleados
    (
		@idempresa as bigint,
		@usuario AS varchar(30),
		@orden as varchar(6),
		@fechaDe as datetime,
		@fechaA as datetime
    )
AS 
   BEGIN 
   
     declare @selectString as varchar(1024)
     declare @fromString as varchar(1024)
     declare @whereString as varchar(1024)
     declare @orderby as varchar(1024) 
     declare @nominas as varchar(1024)
     
	 select @nominas=perfiles.nomina 
	 from perfil_usuarios 
		left join perfiles on perfiles.idperfil=perfil_usuarios.idperfil
	 where perfiles.Sistema='NO'
		and perfil_usuarios.usuario=@usuario
		
	if LEN(@nominas)<=2	
		begin
			set @nominas = 'Todas'
		end	
	else if LEN(@nominas)>2
		begin	
			set @nominas = SUBSTRING(@nominas,2, LEN(@nominas)-2)
		end
    
	 set @selectString = 'Select distinct(empleados.codigo), 
							empleados.nombre, 
							empleados.ap_paterno, 
							empleados.ap_materno, 
							empleados.sindicato,  
							centros.nomdepto, 
							llaves.centro, 
							convert(varchar(10),contratos.fchAlta,103), 
							serial  '
						
	 set @fromString = ' from empleados  
					left join llaves on empleados.codigo=llaves.codigo 
						and llaves.empresa=empleados.empresa
					left join centros on centros.empresa=llaves.empresa
						and llaves.centro=centros.centro
					left join contratos on contratos.empresa=llaves.empresa
						and contratos.codigo=llaves.codigo '
						
	set @whereString = ' where 
					 contratos.fchAlta>= ''' + convert(varchar(10),@fechaDE,112) 
					 + ''' and contratos.fchAlta<=''' +  convert(varchar(10), @fechaa,112) + '''' +
					 ' and empleados.empresa=' + convert(varchar(10),@idempresa)
					 
	if @nominas<>'Todas'
		set @whereString = @whereString + ' and llaves.tiponom in (' + @nominas + ')'
		 
	if @orden = 'Centro'
		set @orderby = 	 ' order by llaves.centro, empleados.codigo '
		
	if @orden = 'Codigo'
		set @orderby = 	 ' order by empleados.codigo, llaves.centro '	 
		 
	exec  ( @selectString + @fromString + @whereString + @orderby)
	
	END
GO   

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.generadorContratosObtenCCPadre')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.generadorContratosObtenCCPadre
GO

CREATE PROCEDURE dbo.generadorContratosObtenCCPadre
    (
      @empresa AS BIGINT,
	  @centroCostos as char(20)
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON 

		--declare @empresa int = 1

		declare @mascara varchar(50)

		select	@mascara=rtrim(ltrim(mascara))
		from dbo.empresas
		where empresa=@empresa

		declare @lenMascara int,
				@met int,
				@niveles int

		set @lenMascara = len(@mascara)
		set @met = 1
		set @niveles = 1

		set @mascara = REPLACE(@mascara,' ','#')

		declare @gruposNiveles as table(grupo varchar(50),nivel int,hasta int)

		while @met<=@lenMascara
		begin
			if SUBSTRING(@mascara,@met,1)='#'
			begin
				insert into @gruposNiveles
				select SUBSTRING(centro,1,@met-@niveles),@niveles,@met-@niveles--,nomdepto
				from dbo.centros
				where empresa=@empresa and centro<>'' and centro<>'99999999999997 '
				group by SUBSTRING(centro,1,@met-@niveles)--,nomdepto		
		
				set @niveles=@niveles+1
			end
			set @met+=1
		end
		--select * from @gruposNiveles
		if @niveles=1
		begin
			insert into @gruposNiveles
			select SUBSTRING(centro,1,@met-@niveles),@niveles,len(@mascara)--,nomdepto
			from dbo.centros
			where empresa=@empresa and centro<>'' and centro<>'99999999999997 '
			group by SUBSTRING(centro,1,@met-@niveles)--,nomdepto		
		end

		--select * from @gruposNiveles


		declare @centros as table(empresa int,centro varchar(50),nombre varchar(max),nivel int, papa varchar(50),serial bigint)

		insert into @centros
		select	empresa,
				rtrim(ltrim(centro)),
				nomdepto,
				cast(defindpto2 as int),
				null,
				DENSE_RANK() OVER (PARTITION BY empresa ORDER BY cast(defindpto2 as int),centro) as serial
		from dbo.centros
		where empresa=@empresa and centro<>'' and centro<>'99999999999997 '

		--select * from @centros order by centro,nivel

		set @met = 1

		while @met<=@niveles
		begin
			--select	*,
			update a set papa=
					case	when @met=1 then a.centro 
							else (	select min(c.centro) 
									from @centros as c 
									where SUBSTRING(c.centro,1,(select max(hasta) from @gruposNiveles where nivel=@met-1))= substring(a.centro,1,(select max(hasta) from @gruposNiveles where nivel=@met-1))
								 )
					end-- as papa
			from @centros as a
			where a.nivel=@met

			set @met = @met + 1
		end
		
		declare @maxSerial bigint
		set @maxSerial = isnull((select max(serial) from @centros),0)
		set @met = 1

		--while @met<=@maxSerial
		--begin
		--	select * 
		--	from llaves 
		--	where centro=(select centro from @centros where serial=@met)

		--	set @met=@met+1
		--end

		select a.papa as padre,
				c.nomdepto
		from @centros as a
		left join @centros as b on a.papa=b.centro
		inner join centros as c on a.papa=c.centro
				and c.empresa=a.empresa
		inner join dbo.empresas as e on e.empresa=a.empresa
		where a.centro=@centroCostos
		order by a.serial

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'generadorContratosValoresNomina'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.generadorContratosValoresNomina
GO

CREATE PROCEDURE dbo.generadorContratosValoresNomina
    (
		@empresa AS bigint,
		@codigo AS bigint,
		@antiguedad AS int,
		@dias as decimal(4,2) = 0
    )
AS 
	BEGIN 
	SET NOCOUNT ON 

	declare @clase as char(1)
	declare @usaConcepto37 as char(1)
    declare @usarConcepto38 as char(1)
	declare @PuntualidadPorcentaje as decimal(10,2)
	declare @PuntualidadImporte as decimal(10,2)
	declare @AsistenciaPorcentaje as decimal(10,2)
	declare @AsistenciaImporte as decimal(10,2)

	select @clase=iif(rtrim(clase)='','',clase)
	from llaves
	where empresa=@empresa
	and codigo=@codigo

	select @PuntualidadImporte=isnull(importe1,0), @PuntualidadPorcentaje=isnull(porciento1,0)
	from conceptos 
	where num_conc =37
	and clase=@clase
	and empresa=@empresa
	and uso='S'

	if isnull(@PuntualidadImporte,0)=0.00 and isnull(@PuntualidadPorcentaje,0)=0.00
		begin 
			select @PuntualidadImporte=importe1, @PuntualidadPorcentaje=porciento1
			from conceptos 
			where num_conc =37
			and clase=''
			and empresa=@empresa
			and uso='S'
		end

	select @AsistenciaImporte=isnull(importe1,0), @AsistenciaPorcentaje=isnull(porciento1,0)
	from conceptos 
	where num_conc =38
	and clase=@clase
	and empresa=@empresa
	and uso='S'
	
	if @AsistenciaPorcentaje is null
		set @AsistenciaPorcentaje=0

	if @AsistenciaImporte is null
		set @AsistenciaImporte=0


	if isnull(@AsistenciaImporte,0)=0.00 and isnull(@AsistenciaPorcentaje,0)=0.00
		begin 
			select @AsistenciaImporte=isnull(importe1,0), @AsistenciaPorcentaje=isnull(porciento1,0)
			from conceptos 
			where num_conc =38
			and clase=''
			and empresa=@empresa
			and uso='S'
		end

	select  llaves.empresa,
		llaves.codigo,
		llaves.clase,
		tablas_int.despensa,
		tablas_int.despensaim,
		tablas_int.fdoahotrap,
		tablas_int.fdoahotrai,
		convert(decimal(12,2),isnull(empleados.sueldo,0)  * isnull(Nominas.frecuencia,0)) as sueldoPeriodico,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * isnull(Nominas.frecuencia,0)) * (tablas_int.despensa/100)) as despensaPeriodico,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * isnull(Nominas.frecuencia,0)) * (tablas_int.fdoahotrap/100)) as fondoAhorroPeriodico,	
		convert(decimal(12,2),isnull(empleados.sueldo,0)) as sueldodiario,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * (tablas_int.despensa/100))) as despensadiario,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * (tablas_int.fdoahotrap/100))) as fondoAhorrodiario,
		convert(decimal(12,2),isnull(empleados.sueldo,0)  *  @dias) as sueldoMensual,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * @dias * (tablas_int.despensa/100))) as despensaMensual,
		convert(decimal(12,2),(isnull(empleados.sueldo,0) * @dias * (tablas_int.fdoahotrap/100))) as fondoAhorroMensual,
		@AsistenciaPorcentaje as PorcentajeAsistencia,
		cast(iif(@AsistenciaPorcentaje=0.00,@AsistenciaImporte,(@AsistenciaPorcentaje/100)* isnull(empleados.sueldo,0)) as decimal(10,2)) as ImporteAsistenciaDiario,
		cast(iif(@AsistenciaPorcentaje=0.00,@AsistenciaImporte,(@AsistenciaPorcentaje/100)* isnull(Nominas.frecuencia,0)*isnull(empleados.sueldo,0)) as decimal(10,2)) as ImporteAsistenciaPeriodico,
		cast(iif(@AsistenciaPorcentaje=0.00,@AsistenciaImporte,(@AsistenciaPorcentaje/100)* @dias*isnull(empleados.sueldo,0)) as decimal(10,2)) as ImporteAsistenciaMensual,
		@PuntualidadPorcentaje as PorcentajePuntualidad,
		cast(iif(@PuntualidadPorcentaje=0.00,@PuntualidadImporte,(@PuntualidadPorcentaje/100)* isnull(empleados.sueldo,0)) as decimal(10,2)) as ImportePuntualidadDiario,
		cast(iif(@PuntualidadPorcentaje=0.00,@PuntualidadImporte,(@PuntualidadPorcentaje/100)* isnull(Nominas.frecuencia,0)*isnull(empleados.sueldo,0)) as decimal(10,2)) as ImportePuntualidadPeriodico,
		cast(iif(@PuntualidadPorcentaje=0.00,@PuntualidadImporte,(@PuntualidadPorcentaje/100)* @dias*isnull(empleados.sueldo,0)) as decimal(10,2)) as ImportePuntualidadMensual,
		convert(bigint,tablas_int.aguinaldo) as diasaguinaldo,
		convert(bigint,tablas_int.dias_vac) as diasvacaciones
	from llaves
		left join clases on clases.empresa=llaves.empresa and clases.clase=llaves.clase
		left join tablas_int on tablas_int.empresa=clases.empresa and tablas_int.clase=clases.clase 
		LEFT join Nominas on nominas.tiponom = llaves.tiponom and nominas.empresa=llaves.empresa  
		left join empleados on llaves.codigo=empleados.codigo and llaves.empresa=empleados.empresa
	where llaves.empresa=@empresa
	and llaves.codigo=@codigo
	and tablas_int.ayos= @antiguedad
	and tablas_int.Mes_Operacion=(select(MAX(Mes_Operacion)) from tablas_int t where t.ayos=@antiguedad and t.empresa=@empresa and t.clase=llaves.clase)

	END
GO             
